<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__arm__system__timer" kind="group">
    <compoundname>group_arm_system_timer</compoundname>
    <title>SysTick      (ARM System Timer)</title>
    <innergroup refid="group__group__systick__macros">Macros</innergroup>
    <innergroup refid="group__group__systick__functions">Functions</innergroup>
    <innergroup refid="group__group__systick__data__structures">Data Structures</innergroup>
    <briefdescription>
<para>Provides vendor-specific SysTick API. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_systick.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The SysTick timer is part of the CPU. The timer is a down counter with a 24-bit reload/tick value that is clocked by the FastClk/SlowClk. The timer has the capability to generate an interrupt when the set number of ticks expires and the counter is reloaded. This interrupt is available as part of the Nested Vectored Interrupt Controller (NVIC) for service by the CPU and can be used for general-purpose timing control in user code.</para><para>The timer is independent of the CPU (except for the clock), which is useful in applications requiring precise timing that do not have a dedicated timer/counter available for the job.</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>The <ref kindref="member" refid="group__group__systick__functions_1gac600820b0201e4ad5a171e97f7642c62">Cy_SysTick_Init()</ref> performs all required driver's initialization and enables the timer. The function accepts two parameters: clock source <ref kindref="member" refid="group__group__systick__data__structures_1ga466b1e8fe4278011eab77a691ce2b8f9">cy_en_systick_clock_source_t</ref> and the timer interval. You must ensure the selected clock source for SysTick is enabled. The callbacks can be registered/unregistered any time after <ref kindref="member" refid="group__group__systick__functions_1gac600820b0201e4ad5a171e97f7642c62">Cy_SysTick_Init()</ref> by calling <ref kindref="member" refid="group__group__systick__functions_1gac20a2349069c5268c6e3f05c6777b9c9">Cy_SysTick_SetCallback()</ref>.</para><para>Changing the SysTick clock source and/or its frequency will change the interrupt interval and therefore <ref kindref="member" refid="group__group__systick__functions_1ga55c016caf7558ec00f1e8cd3d77e36da">Cy_SysTick_SetReload()</ref> should be called to compensate for this change.</para>

<para><heading level="1">More Information</heading></para>
<para>Refer to the SysTick section of the ARM reference guide for complete details on the registers and their use. See also the "CPU Subsystem (CPUSS)" chapter of the device technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;8.12 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Required &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;When an array is declared with external linkage, its size shall be stated explicitly or defined implicitly by initialization. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The warning is related to the __ramVectors symbol defined in the assembly startup code. It's size is device-specific and unknown to the SysTick driver.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.20. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated &lt;a href="group__group__systick__functions.html#group__group__systick__functions_1gaa8a72d8a278e4a3a970b4c4a021f3647"&gt;Cy_SysTick_SetClockSource()&lt;/a&gt; for the PSoC 64 devices, so that passing any other value than CY_SYSTICK_CLOCK_SOURCE_CLK_CPU will not affect clock source and it will be as &lt;a href="group__group__systick__functions.html#group__group__systick__functions_1ga6d72adec7b58994ff9097bb4a301fa95"&gt;Cy_SysTick_GetClockSource()&lt;/a&gt; reports. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added PSoC 64 devices support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated include files. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improve pdl usability.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fixed a warning issued when the compilation of C++ source code was enabled. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>